org.apache.lucene.search

## Class RemoteSearchable

- java.lang.Object
- - java.rmi.server.RemoteObject
  - - java.rmi.server.RemoteServer
    - - java.rmi.server.UnicastRemoteObject
      - - org.apache.lucene.search.RemoteSearchable

- All Implemented Interfaces:
    java.io.Serializable, java.rmi.Remote, RMIRemoteSearchable, Searchable

      public class RemoteSearchable
      extends java.rmi.server.UnicastRemoteObject
      implements RMIRemoteSearchable

  A remote searchable implementation.
  Version:
    $Id: RemoteSearchable.java 803339 2009-08-12 01:22:30Z markrmiller $
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class java.rmi.server.RemoteObject

      `ref`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RemoteSearchable(Searchable local)` Constructs and exports a remote searcher.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Frees resources associated with this Searcher.
    `Document` | `doc(int i)` Returns the stored fields of document `i`.
    `Document` | `doc(int i, FieldSelector fieldSelector)` Get the `Document` at the `n`th position.
    `int` | `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
    `int[]` | `docFreqs(Term[] terms)` Expert: For each term in the terms array, calculates the number of documents containing `term`.
    `Explanation` | `explain(Weight weight, int doc)` Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.
    `static void` | `main(java.lang.String[] args)` Exports a searcher for the index in args[0] named "//localhost/Searchable".
    `int` | `maxDoc()` Expert: Returns one greater than the largest possible document number.
    `Query` | `rewrite(Query original)` Expert: called to re-write queries into primitive queries.
    `void` | `search(Weight weight, Filter filter, Collector results)` Lower-level search API.
    `void` | `search(Weight weight, Filter filter, HitCollector results)` Deprecated. use `search(Weight, Filter, Collector)` instead.
    `TopDocs` | `search(Weight weight, Filter filter, int n)` Expert: Low-level search implementation.
    `TopFieldDocs` | `search(Weight weight, Filter filter, int n, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.

    - ### Methods inherited from class java.rmi.server.UnicastRemoteObject

      `clone, exportObject, exportObject, exportObject, unexportObject`

    - ### Methods inherited from class java.rmi.server.RemoteServer

      `getClientHost, getLog, setLog`

    - ### Methods inherited from class java.rmi.server.RemoteObject

      `equals, getRef, hashCode, toString, toStub`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### RemoteSearchable

          public RemoteSearchable(Searchable local)
                           throws java.rmi.RemoteException

      Constructs and exports a remote searcher.
      Throws:
        `java.rmi.RemoteException`

  - ### Method Detail

    - #### search

          public void search(Weight weight,
                             Filter filter,
                             HitCollector results)
                      throws java.io.IOException

      Deprecated. use `search(Weight, Filter, Collector)` instead.
      Description copied from interface: `Searchable`
      Lower-level search API.

      `HitCollector.collect(int,float)` is called for every non-zero scoring document.
      HitCollector-based access to remote indexes is discouraged.

      Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

      Specified by:
        `search` in interface `Searchable`
      Parameters:
        `weight` - to match documents
        `filter` - if non-null, used to permit documents to be collected.
        `results` - to receive hits
      Throws:
        `java.io.IOException`

    - #### search

          public void search(Weight weight,
                             Filter filter,
                             Collector results)
                      throws java.io.IOException

      Description copied from interface: `Searchable`
      Lower-level search API.

      `Collector.collect(int)` is called for every document.
      Collector-based access to remote indexes is discouraged.

      Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

      Specified by:
        `search` in interface `Searchable`
      Parameters:
        `weight` - to match documents
        `filter` - if non-null, used to permit documents to be collected.
        `results` - to receive hits
      Throws:
        `java.io.IOException`

    - #### close

          public void close()
                     throws java.io.IOException

      Description copied from interface: `Searchable`
      Frees resources associated with this Searcher. Be careful not to call this method while you are still using objects like `Hits`.
      Specified by:
        `close` in interface `Searchable`
      Throws:
        `java.io.IOException`

    - #### docFreq

          public int docFreq(Term term)
                      throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: Returns the number of documents containing `term`.
      Specified by:
        `docFreq` in interface `Searchable`
      Throws:
        `java.io.IOException`
      See Also:
        `IndexReader.docFreq(Term)`

    - #### docFreqs

          public int[] docFreqs(Term[] terms)
                         throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: For each term in the terms array, calculates the number of documents containing `term`. Returns an array with these document frequencies. Used to minimize number of remote calls.
      Specified by:
        `docFreqs` in interface `Searchable`
      Throws:
        `java.io.IOException`

    - #### maxDoc

          public int maxDoc()
                     throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: Returns one greater than the largest possible document number.
      Specified by:
        `maxDoc` in interface `Searchable`
      Throws:
        `java.io.IOException`
      See Also:
        `IndexReader.maxDoc()`

    - #### search

          public TopDocs search(Weight weight,
                                Filter filter,
                                int n)
                         throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

      Applications should usually call `Searcher.search(Query)` or `Searcher.search(Query,Filter)` instead.

      Specified by:
        `search` in interface `Searchable`
      Throws:
        `java.io.IOException`

    - #### search

          public TopFieldDocs search(Weight weight,
                                     Filter filter,
                                     int n,
                                     Sort sort)
                              throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

      Applications should usually call `Searcher.search(Query,Filter,int,Sort)` instead.

      Specified by:
        `search` in interface `Searchable`
      Throws:
        `java.io.IOException`

    - #### doc

          public Document doc(int i)
                       throws CorruptIndexException,
                              java.io.IOException

      Description copied from interface: `Searchable`
      Returns the stored fields of document `i`.
      Specified by:
        `doc` in interface `Searchable`
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error
      See Also:
        `IndexReader.document(int)`

    - #### doc

          public Document doc(int i,
                              FieldSelector fieldSelector)
                       throws CorruptIndexException,
                              java.io.IOException

      Description copied from interface: `Searchable`
      Get the `Document` at the `n`th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If the underlying Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.
      Specified by:
        `doc` in interface `Searchable`
      Parameters:
        `i` - Get the document at the `n`th position
        `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
      Returns:
        The stored fields of the `Document` at the nth position
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error
      See Also:
        `IndexReader.document(int, FieldSelector)`, `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

    - #### rewrite

          public Query rewrite(Query original)
                        throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: called to re-write queries into primitive queries.
      Specified by:
        `rewrite` in interface `Searchable`
      Throws:
        `java.io.IOException`

    - #### explain

          public Explanation explain(Weight weight,
                                     int doc)
                              throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.

      This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

      Applications should call `Searcher.explain(Query, int)`.

      Specified by:
        `explain` in interface `Searchable`
      Throws:
        `java.io.IOException`

    - #### main

          public static void main(java.lang.String[] args)
                           throws java.lang.Exception

      Exports a searcher for the index in args[0] named "//localhost/Searchable".
      Throws:
        `java.lang.Exception`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.